//package eu.eudat.model.builder.filetransformer;
//
//import eu.eudat.authorization.AuthorizationFlags;
//import eu.eudat.commons.JsonHandlingService;
//import eu.eudat.commons.XmlHandlingService;
//import eu.eudat.convention.ConventionService;
//import eu.eudat.data.DescriptionTemplateEntity;
//import eu.eudat.file.transformer.models.descriptiontemplate.DescriptionTemplateFileTransformerModel;
//import eu.eudat.query.DescriptionTemplateQuery;
//import gr.cite.tools.data.builder.BuilderFactory;
//import gr.cite.tools.data.query.QueryFactory;
//import gr.cite.tools.exception.MyApplicationException;
//import gr.cite.tools.logging.LoggerService;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.config.ConfigurableBeanFactory;
//import org.springframework.context.annotation.Scope;
//import org.springframework.stereotype.Component;
//
//import java.util.ArrayList;
//import java.util.EnumSet;
//import java.util.List;
//import java.util.Optional;
//
//@Component
//@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
//public class DescriptionTemplateFileTransformerBuilder extends BaseFileTransformerBuilder<DescriptionTemplateFileTransformerModel, DescriptionTemplateEntity> {
//
//    private final QueryFactory queryFactory;
//
//    private final BuilderFactory builderFactory;
//    private final JsonHandlingService jsonHandlingService;
//
//    private final XmlHandlingService xmlHandlingService;
//    private EnumSet<AuthorizationFlags> authorize = EnumSet.of(AuthorizationFlags.None);
//
//    @Autowired
//    public DescriptionTemplateFileTransformerBuilder(
//		    ConventionService conventionService,
//		    QueryFactory queryFactory,
//		    BuilderFactory builderFactory, JsonHandlingService jsonHandlingService, XmlHandlingService xmlHandlingService) {
//        super(conventionService, new LoggerService(LoggerFactory.getLogger(DescriptionTemplateFileTransformerBuilder.class)));
//        this.queryFactory = queryFactory;
//        this.builderFactory = builderFactory;
//        this.jsonHandlingService = jsonHandlingService;
//	    this.xmlHandlingService = xmlHandlingService;
//    }
//
//    public DescriptionTemplateFileTransformerBuilder authorize(EnumSet<AuthorizationFlags> values) {
//        this.authorize = values;
//        return this;
//    }
//
//    @Override
//    protected List<FileTransformerBuilderItemResponse<DescriptionTemplateFileTransformerModel, DescriptionTemplateEntity>> buildInternal(List<DescriptionTemplateEntity> data) throws MyApplicationException {
//        this.logger.debug("building for {}", Optional.ofNullable(data).map(List::size).orElse(0));
//        if (data == null || data.isEmpty()) return new ArrayList<>();
//
//        data = queryFactory.query(DescriptionTemplateQuery.class).ids(data.stream().map(DescriptionTemplateEntity::getId).toList()).collect();
//        List<FileTransformerBuilderItemResponse<DescriptionTemplateFileTransformerModel, DescriptionTemplateEntity>> models = new ArrayList<>();
//        for (DescriptionTemplateEntity d : data) {
//
//            DescriptionTemplateFileTransformerModel m = new DescriptionTemplateFileTransformerModel();
//            m.setId(d.getId());
//            m.setLabel(d.getLabel());
//            m.setDescription(d.getDescription());
//            m.setLanguage(d.getLanguage());
//            m.setVersion(d.getVersion());
//            m.setDefinition(this.builderFactory.builder(DescriptionTemplateDefinitionFileTransformerBuilder.class).authorize(authorize).build(collectDescriptionTemplates(d)));
//
//            models.add(new FileTransformerBuilderItemResponse<>(m, d));
//        }
//
//        this.logger.debug("build {} items", Optional.of(models).map(List::size).orElse(0));
//
//        return models;
//    }
//
//    private eu.eudat.commons.types.descriptiontemplate.DefinitionEntity collectDescriptionTemplates(DescriptionTemplateEntity data) throws MyApplicationException {
//        return this.xmlHandlingService.fromXmlSafe(eu.eudat.commons.types.descriptiontemplate.DefinitionEntity.class, data.getDefinition());
//    }
//
//}
