package eu.eudat.model.persist.externalfetcher;

import gr.cite.tools.validation.ValidatorFactory;
import gr.cite.tools.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class ExternalFetcherStaticOptionSourceConfigurationPersist extends ExternalFetcherBaseSourceConfigurationPersist {

    List<StaticOptionPersist> options;

    public static final String _options = "options";

    public List<StaticOptionPersist> getOptions() {
        return options;
    }

    public void setOptions(List<StaticOptionPersist> options) {
        this.options = options;
    }

    @Component(ExternalFetcherStaticOptionSourceConfigurationPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class ExternalFetcherStaticOptionSourceConfigurationPersistValidator extends ExternalFetcherBaseSourceConfigurationPersistValidator<ExternalFetcherStaticOptionSourceConfigurationPersist> {

        public static final String ValidatorName = "ExternalFetcherStaticOptionSourceConfigurationPersistValidator";

        protected ExternalFetcherStaticOptionSourceConfigurationPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource, validatorFactory);
        }

        @Override
        protected Class<ExternalFetcherStaticOptionSourceConfigurationPersist> modelClass() {
            return ExternalFetcherStaticOptionSourceConfigurationPersist.class;
        }

        @Override
        protected List<Specification> specifications(ExternalFetcherStaticOptionSourceConfigurationPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.add(
                    this.navSpec()
                            .iff(() -> !this.isListNullOrEmpty(item.getOptions()))
                            .on(ExternalFetcherStaticOptionSourceConfigurationPersist._options)
                            .over(item.getOptions())
                            .using((itm) -> this.validatorFactory.validator(StaticOptionPersist.ReferenceTypeStaticOptionPersistValidator.class))
            );
            return specifications;
        }
    }

}
